/*****************************/
/*  sem_config.h by IoDream  */
/* sem global definitions    */
/*   Not released yet        */
/*      PUBLIC DOMAIN        */
/*****************************/

/* IoDream (IoDream@ifrance.com) */

#ifndef sem_config_h
#define sem_config_h

/* C++ compilers friendly */
#ifdef __cplusplus
extern "C" {
#endif /*__cplusplus*/

/* Maximal size of a semaphore message */
#define SEM_MAXLEN_MESSAGE 50
/* Maximal number of semaphore IDs */
#define SEM_MAXID 5
/* Init. of all the semaphores */
#define SEM_SEMINIT 1
/* Listening port number. 0 => allocated by the system */
#define SEM_LISTENING_PORT 0
/* Maximum number of accepted connections. Real maximum is SOMAXCONN */
#define SEM_MAXNB_CLIENTS 4
/* Name of the file where you can find the PID of the sem_gest() function processus */
#define SEM_SERVER_PID_FILENAME "sem_server.pid"
/* Name of the file where you can find the port number of the sem_sock_server() function processus */
#define SEM_SERVER_PORT_FILENAME "sem_server.port"

/* C++ compilers friendly */
#ifdef __cplusplus
}
#endif /*__cplusplus*/

#endif /*sem_config_h*/
